/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.KecamatanDto;
import com.portofolio.service.KecamatanService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/kecamatan")
public class KecamatanController extends LocaleController {
	@Lazy
	@Autowired
	private KecamatanService kecamatanService;

	@ApiOperation("Api Untuk Menyimpan Kecamatan")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody KecamatanDto entity, HttpServletRequest request) {
		Map<String, Object> result = kecamatanService.save(entity);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Update Kecamatan")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdKecamatan", required = true) Integer kdKecamatan,
			@RequestParam(value = "version", required = true) Integer version,
			@Valid @RequestBody KecamatanDto entity,
			HttpServletRequest request) {
		Map<String, Object> result = kecamatanService.update(entity, kdKecamatan,version);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menghapus Kecamatan BerdasarkanKdKecamatan")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> deleteById(
			@RequestParam(value = "kdKecamatan", required = true) Integer kdKecamatan,
			@RequestParam(value = "version", required = true) Integer version) {
		Map<String, Object> result = kecamatanService.deleteByKode(kdKecamatan, version);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Semua Kecamatan")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> grid(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = stringAsIntegerMaxValue) Integer rows,
			@RequestParam(value = "dir", defaultValue = "namaKecamatan") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaKecamatan", required = false, defaultValue = "") String namaKecamatan,
			@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
		Map<String, Object> result = kecamatanService.grid(page, rows, sort, dir, namaKecamatan, statusEnabled);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Kecamatan Berdasarkan kode")
	@GetMapping("/findByKdKecamatan")
	public ResponseEntity<Map<String, Object>> findByKode(
			@RequestParam(value = "kdKecamatan", required = true) Integer kdKecamatan,
			HttpServletRequest request) {
		Map<String, Object> result = kecamatanService.findByKdKecamatan(kdKecamatan);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Semua Kecamatan")
	@GetMapping("/findByKdKotaKabupaten")
	public ResponseEntity<Map<String, Object>> findAllKecamatan(@RequestParam(value = "kdKotaKabupaten") Integer kdKotaKabupaten) {
		Map<String, Object> result = kecamatanService.findByKdKotaKabupaten(kdKotaKabupaten);
		return RestUtil.getJsonResponse(result);
	}

}
